<?php

/*

Plugin Name: User Control

Plugin URI: http://www.iwebux.com

Description: Disable/Enable Users

Version: 1.1.1

Author: Surendhar Rajahram 

Author URI: http://www.iwebux.com

*/


/*  Copyright 2010  Iwebux  (url- http://iwebux.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

global $wpdb;

global $default;

 if(isset($_POST['disabledefault']))
 {
			$wpdb->query("UPDATE ".$wpdb->prefix."default_status SET status = 'disabled'");
			
 }
 else if(isset($_POST['enabledefault']))
 {
 			$wpdb->query("UPDATE ".$wpdb->prefix."default_status SET status = 'enabled'");
 }


 $default = $wpdb->get_row("SELECT status from ".$wpdb->prefix."default_status");


if(isset($_POST['disable']))
{
	foreach ( $_POST['users'] as $userid ) {
		$wpdb->query("UPDATE ".$wpdb->prefix."usercontrol SET disable_status = 'disabled' WHERE ID = ".$wpdb->escape($userid));
	}
}

if(isset($_POST['enable']))
{
	foreach ( $_POST['users'] as $userid ) {
		$wpdb->query("UPDATE ".$wpdb->prefix."usercontrol SET disable_status = 'enabled' WHERE ID = ".$wpdb->escape($userid));
	}
}


function checkstatus() {
   global $current_user;
   global $wpdb;
   get_currentuserinfo();
   
  $row = $wpdb->get_row("SELECT disable_status FROM ".$wpdb->prefix."usercontrol WHERE ID = ".$current_user->ID);
 
  if ($row->disable_status == 'disabled') {
	wp_redirect(get_option('siteurl') . '/wp-login.php');
	wp_logout();
  }
}

add_action('init', 'checkstatus');


function set_users()
{
   global $wpdb;
   
   global $default;

   echo "<div id=\"message\" class=\"updated fade\"><p><strong>New users ". $default->status ." by default.</strong></p></div>";
   
	?>
    
   <form action="" method="post" id="usercontrol">
    <table class="widefat fixed" cellspacing="0">
    <thead>
    <tr class="thead">
    <th style="" class="manage-column column-cb check-column" id="cb" scope="col"><input type="checkbox"></th>
	<th style="" class="manage-column column-username" id="username" scope="col">Username</th>
	<th style="" class="manage-column column-status" id="status" scope="col">Status</th>
	<th style="" class="manage-column column-email" id="email" scope="col">E-mail</th>
	<th style="" class="manage-column column-role" id="role" scope="col">Role</th>
	
    </tr>
    </thead>
    
    <tfoot>
    <tr class="thead">
    <th style="" class="manage-column column-cb check-column" id="cb" scope="col"><input type="checkbox"></th>
	<th style="" class="manage-column column-username" id="username" scope="col">Username</th>
	<th style="" class="manage-column column-status" id="status" scope="col">Status</th>
	<th style="" class="manage-column column-email" id="email" scope="col">E-mail</th>
	<th style="" class="manage-column column-role" id="role" scope="col">Role</th>
	
    </tr>
    </tfoot>

    
    <tbody id="users" class="list:user user-list">
	<?php
    $style = '';
	$result = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."usercontrol");
    foreach ( $result as $row) {
        $user_object = new WP_User($row->ID);
        $roles = $user_object->roles;
        $role = array_shift($roles);
    
        $style = ( ' class="alternate"' == $style ) ? '' : ' class="alternate"';
        echo "\n\t" . '<tr class="'.$style.'" id="user-'.$row->ID.'">
		<th class="check-column" scope="row"><input type="checkbox" value="'.$row->ID.'" class="editor" id="user_'.$row->ID.'" name="users[]"></th><td class="username column-username">'.$row->user_nicename.'</td><td class="name column-status">'.$row->disable_status.'</td><td class="email column-email"><a title="e-mail:'.$row->user_email.'" href="mailto:'.$row->user_email.'">'.$row->user_email.'</a></td><td class="role column-role">'.$role.'</td></tr>';
    }
    ?>
    </tbody>
    </table>
    <div class="alignleft actions">
    	<br /><input type="submit" value="<?php esc_attr_e('Disable'); ?>" name="disable" id="disable" class="button-secondary action" />
        <input type="submit" value="<?php esc_attr_e('Enable'); ?>" name="enable" id="enable" class="button-secondary action" /><br /><br />
        
        <b>Note: The following controls the default status of the new users. You can later enable/approve your new users.</b> <br /><br /> 
        
        <input type="submit" value="<?php esc_attr_e('Disable new users by default '); ?>" name="disabledefault" id="disabledefault" class="button-secondary action" />
        
        <input type="submit" value="<?php esc_attr_e('Enable new users by default '); ?>" name="enabledefault" id="enabledefault" class="button-secondary action" />
        
    </div>
    
    </form>
    
 <?php 

}



function user_control() {
	
	global $wpdb;
	global $default;
	
	$wpdb->query("Delete from  ".$wpdb->prefix."usercontrol where id NOT IN (select ID from $wpdb->users)");
	
	$result = $wpdb->get_col( $wpdb->prepare("SELECT $wpdb->users.ID FROM $wpdb->users WHERE ID != 1 and ID NOT IN (select id from ".$wpdb->prefix."usercontrol)"));
	
    foreach ( $result as $userid ) {
		$user = get_userdata($userid);
		$wpdb->query("INSERT INTO ".$wpdb->prefix."usercontrol (ID, user_login, user_nicename, user_email, disable_status) VALUES (".$user->ID.",'".$user->user_login."','".$user->user_nicename."','".$user->user_email."','".$default->status."');");
	}

	add_menu_page( 'User Enable/Disable','User Control',9, 'User Control', 'set_users' );
	

}

add_action('admin_menu', 'user_control');



function anonymous_user(){
	
	
	global $wpdb;
	global $default;
	
	$wpdb->query("Delete from  ".$wpdb->prefix."usercontrol where id NOT IN (select ID from $wpdb->users)");
	
	$result = $wpdb->get_col( $wpdb->prepare("SELECT $wpdb->users.ID FROM $wpdb->users WHERE ID != 1 and ID NOT IN (select id from ".$wpdb->prefix."usercontrol)"));
	
    foreach ( $result as $userid ) {
		$user = get_userdata($userid);
		$wpdb->query("INSERT INTO ".$wpdb->prefix."usercontrol (ID, user_login, user_nicename, user_email, disable_status) VALUES (".$user->ID.",'".$user->user_login."','".$user->user_nicename."','".$user->user_email."','".$default->status."');");
	}
	
	
}


add_action('user_register', 'anonymous_user');

add_action('wpmu_activate_signup', 'anonymous_user');


function addStatus()
{
	global $wpdb;
	$wpdb->query( "CREATE TABLE IF NOT EXISTS ".$wpdb->prefix."usercontrol (
		ID bigint(20) NOT NULL,
		user_login varchar(60) NOT NULL,
		user_nicename varchar(50) NOT NULL,
		user_email varchar(100) NOT NULL,
		disable_status varchar(10) NOT NULL DEFAULT 'enabled',
		PRIMARY KEY (ID));" );
	$wpdb->query( "CREATE TABLE IF NOT EXISTS ".$wpdb->prefix."default_status (
		ID bigint(20) NOT NULL,
		status varchar(10) NOT NULL,
		PRIMARY KEY (ID));" );
	$wpdb->query( "INSERT INTO ".$wpdb->prefix."default_status values(1,'enabled')");
}


add_action('activate_'.plugin_basename( __FILE__ ),'addStatus' );

function dropStatus()
{
	global $wpdb;
	$wpdb->query("DROP TABLE ".$wpdb->prefix."usercontrol");
	$wpdb->query("DROP TABLE ".$wpdb->prefix."deafult_status");
}

add_action('deactivate_'.plugin_basename( __FILE__ ),'dropStatus' );

?>